require "config"

local mod_version="0.1.1"

local autofabs={}

---[[
local function print(...)
  return game.player.print(...)
end
--]]

local debug=function() end
if debug_mode then
  debug=print
end


local function onLoad()
  if global.autofabs==nil then
    global.autofabs={}
  end
  autofabs=global.autofabs
end

local function onSave()
  global.autofabs=autofabs
end

local function onTick(event)
  for i=1,#autofabs do
    local autofab=autofabs[i]
    if autofab.state=="offline" and autofab.entity.valid then
      if autofab.entity.is_crafting() then
        --crafting! replace the original blueprint
        debug("crafting has begun")
        autofab.state="copying"
        --autofab.entity.insert{name="blueprint",type="item",count=1}
        --local newbp=autofab.entity.get_inventory(2)[1]
        --debug("newbp = "..(newbp==nil and "nil" or newbp.type))
        --debug("# entities: "..#autofab.template_entities)
        --newbp.set_blueprint_entities(autofab.template_entities)
        --newbp.blueprint_icons=autofab.template_icons
        --debug("icon 0:"..autofab.template_icons[0].name)
      else
        if autofab.entity.recipe==nil then
          autofab.entity.recipe="blueprint-copy"
        end
        local bp1 = autofab.entity.get_inventory(2)[1]
        if bp1 and bp1.valid_for_read then
          --grab it's stuff
          autofab.template_entities=bp1.get_blueprint_entities()
          autofab.template_icons=bp1.blueprint_icons
          debug("grabbing template...")
          debug("icon 0:"..autofab.template_icons[0].name)
          debug("# entites :"..#autofab.template_entities)
        end
      end
    elseif autofab.state=="copying" then
      if autofab.entity.is_crafting()==false then
        autofab.state="offline"
        --restore the output blueprint details
        local newbp=autofab.entity.get_inventory(3)[1]
        if newbp and newbp.valid_for_read and newbp.is_blueprint_setup()==false then
          newbp.set_blueprint_entities(autofab.template_entities)
          newbp.blueprint_icons=autofab.template_icons
        end
        --build!
        local entitys = {}
        
        for k,v in pairs(autofab.template_entities) do
          local ghost={}
          for k,v in pairs(v) do
            ghost[k]=v
          end
          ghost.inner_name=v.name
          ghost.position.x=ghost.position.x+autofab.entity.position.x-1
          ghost.position.y=ghost.position.y+autofab.entity.position.y-1
          ghost.name="entity-ghost"
          ghost.force=autofab.entity.force
          entitys[k] = game.surfaces.nauvis.create_entity(ghost) -- We might need to trigger the on_built
        end
        
        --debug (serpent.dump (autofab.template_entities))
        
        for template_entity_id,template_entity in pairs (autofab.template_entities) do
          local start = entitys[template_entity_id] -- We need to convert the blueprint entity ids to the real once and then get the entity wich belongs to it
          --debug ("test "..template_entity.name)
          if template_entity.connections then
            --debug ("Number of v.connections " .. #template_entity.connections)
            for source_circuit_id,v in pairs (template_entity.connections) do
              for wire_type,targets in pairs (v) do
                for index, target in pairs (targets) do
                  local real_target = entitys[target.entity_id] -- Convert blueprint id to real one and get the entity
                  -- This is where the magic for wires happens
                  local results = start.connect_neighbour ({wire = defines.circuitconnector[wire_type],target_entity = real_target,
                      source_circuit_id = source_circuit_id,target_circuit_id = target.circuit_id})
                end
              end
            end
          end
        end
      end
    end
  end
end

local function onPlace(event)
  if event.created_entity.name == "test-container" then
    debug("placed autofab")
    autofabs[#autofabs+1]={entity=event.created_entity,state="offline"}
  end
end

local function onRemove(event)
  if event.entity.name == "autofab" then
    for i=1,#autofabs do
      if autofabs[i].entity==event.entity then
        table.remove(autofabs,i)
        break
      end
    end
  end
end

game.on_init(onLoad)
game.on_load(onLoad)

game.on_save(onSave)

game.on_event(defines.events.on_tick,onTick)

game.on_event(defines.events.on_built_entity,onPlace)
game.on_event(defines.events.on_robot_built_entity,onPlace)

game.on_event(defines.events.on_preplayer_mined_item, onRemove)
game.on_event(defines.events.on_robot_pre_mined, onRemove)
game.on_event(defines.events.on_entity_died, onRemove)
