data:extend(
{
  {
    type = "recipe-category",
    name = "blueprint-operation"
  },
  {
    type = "item",
    name = "test-container",
    icon = "__autofab__/graphics/autofab-icon.png",
    flags = {"goes-to-quickbar"},
    subgroup = "circuit-network",
    order = "c-f",
    place_result = "test-container",
    stack_size = 50,
  },
  {
    type = "recipe",
    name = "blueprint-copy",
    category = "blueprint-operation",
    energy_required = 1,
    ingredients =
      {
        { "blueprint", 1 },
      },
    result = "blueprint",
    result_count=1,
    hidden = "true",
  },
  {
    type = "recipe",
    name = "test-container",
    enabled = "false",
    ingredients =
      {
        { "iron-plate", 5 },
        { "advanced-circuit", 50 },
        { "construction-robot", 1 },
      },
    result = "test-container",
  },
  {
    type = "assembling-machine",
    name = "test-container",
    icon = "__autofab__/graphics/autofab-icon.png",
    flags = {"placeable-neutral", "placeable-player", "player-creation"},
    minable = {mining_time = 1, result = "test-container"},
    max_health = 50,
    corpse = "small-remnants",
    repair_sound = { filename = "__base__/sound/manual-repair-simple.ogg" },
    mined_sound = { filename = "__base__/sound/deconstruct-bricks.ogg" },
    ingredient_count=1,
    resistances =
    {
      {
        type = "fire",
        percent = 80
      },
      {
        type = "explosion",
        percent = 30
      }
    },
    collision_box = {{-0.3, -0.3}, {0.3, 0.3}},
    selection_box = {{-0.5, -0.6}, {0.6, 0.5}},
    crafting_categories = {"blueprint-operation"},
    result_inventory_size = 2,
    energy_usage = "180kW",
    crafting_speed = 1,
    source_inventory_size = 2,
    animation =
      {
        filename = "__autofab__/graphics/autofab.png",
        priority = "high",
        width = 42,
        height = 33,
        frame_count = 1,
        line_length = 0,
        shift = {0.3, -0.0},
      },
    energy_source=
      {
        type = "electric",
        usage_priority = "secondary-input",
        emissions = 0.005
      },
  },
  
  {
    type = "technology",
    name = "automated-construction-2",
    icon = "__autofab__/graphics/autofab-icon.png",
    effects = {
      {
        type = "unlock-recipe",
        recipe = "test-container"
      },
    },
    prerequisites = {"automated-construction"},
    unit =
    {
      count = 150,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
      },
      time = 30
    },
    order = "c-k-b",
  },

})